From 83e3fec35a31737bbeb542d9ece5adc9a3ce8efb Mon Sep 17 00:00:00 2001
From: sah4009 <peter.deherdt@softathome.com>
Date: Mon, 16 Sep 2019 09:23:00 +0000
Subject: [PATCH] Lua 5.3 support

---
 lua/CMakeLists.txt |  3 ++-
 lua/uloop.c        | 19 ++++++++++++++++++-
 2 files changed, 20 insertions(+), 2 deletions(-)

diff --git a/lua/CMakeLists.txt b/lua/CMakeLists.txt
index 34c9ab1..57bac63 100644
--- a/lua/CMakeLists.txt
+++ b/lua/CMakeLists.txt
@@ -5,7 +5,7 @@ PROJECT(uloop C)
 SET(CMAKE_INSTALL_PREFIX /)
 
 IF(NOT LUA_CFLAGS)
-	pkg_search_module(LUA lua5.1 lua-5.1)
+	pkg_search_module(LUA lua5.3 lua-5.3)
 ENDIF()
 
 ADD_DEFINITIONS(-Os -Wall -Werror --std=gnu99 -g3 -I.. ${LUA_CFLAGS})
@@ -37,6 +37,7 @@ IF(BUILD_LUA)
 		PREFIX ""
 	)
 	TARGET_LINK_LIBRARIES(uloop_lua ubox)
+	TARGET_LINK_LIBRARIES(uloop_lua -llua)
 
 	INSTALL(TARGETS uloop_lua
 		LIBRARY DESTINATION ${LUAPATH}
diff --git a/lua/uloop.c b/lua/uloop.c
index 1b0389f..b2de75d 100644
--- a/lua/uloop.c
+++ b/lua/uloop.c
@@ -18,6 +18,7 @@
 #include <stdlib.h>
 #include <unistd.h>
 
+#define LUA_COMPAT_OPENLIB
 #include <lua.h>
 #include <lualib.h>
 #include <lauxlib.h>
@@ -25,6 +26,11 @@
 #include "../uloop.h"
 #include "../list.h"
 
+#if LUA_VERSION_NUM > 501
+#define luaL_optint luaL_optinteger
+#define lua_objlen lua_rawlen
+#endif
+
 struct lua_uloop_fd {
 	struct uloop_fd fd;
 	int r;
@@ -57,7 +63,11 @@ ul_create_userdata(lua_State *L, size_t size, const luaL_Reg *reg, lua_CFunction
 	lua_pushvalue(L, -1);
 	lua_setmetatable(L, -3);
 	lua_pushvalue(L, -2);
+#if LUA_VERSION_NUM > 501
+	luaL_setfuncs(L, reg, 1);
+#else
 	luaI_openlib(L, NULL, reg, 1);
+#endif
 	lua_pushvalue(L, -2);
 
 	return ret;
@@ -408,7 +418,7 @@ static int ul_end(lua_State *L)
 	return 1;
 }
 
-static luaL_reg uloop_func[] = {
+static luaL_Reg uloop_func[] = {
 	{"init", ul_init},
 	{"run", ul_run},
 	{"timer", ul_timer},
@@ -432,7 +442,14 @@ int luaopen_uloop(lua_State *L)
 	lua_createtable(L, 1, 0);
 	lua_setglobal(L, "__uloop_fds");
 
+#if LUA_VERSION_NUM > 501
+	lua_newtable(L);
+    luaL_setfuncs (L, uloop_func, 0);
+    lua_pushvalue(L, -1);
+    lua_setglobal(L, "uloop");
+#else
 	luaL_openlib(L, "uloop", uloop_func, 0);
+#endif
 	lua_pushstring(L, "_VERSION");
 	lua_pushstring(L, "1.0");
 	lua_rawset(L, -3);
-- 
2.26.2

